C ********************************************************************
C
C     SUBROUTINE CAHM :CONSTRUCTION OF HAMILTONIAN WITH RESPECT TO
C                      K VECTOR  AR(NM1,NM1),AI(NM1,NM1) FOR EISPACK
C
C ********************************************************************
      SUBROUTINE CAHM(NA,XK,YK,ZK,NN,DX,DY,DZ,EI,AR,AI,HM,NM1,IP,MAN)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION DX(MAN,NA),DY(MAN,NA),DZ(MAN,NA),EI(4,NA),AR(NM1,NM1)
     &         ,HM(4,4,MAN,NA),IP(MAN,NA),NN(NA),AI(NM1,NM1)

c      WRITE(6,601) nm1
c  601 FORMAT(1H ,4Hnm1=,I3)
      DO 100 I=1,NM1
      DO 110 J=1,NM1
      AR(J,I)=0.0D0
      AI(J,I)=0.0D0
  110 CONTINUE
  100 CONTINUE
      DO 120 I=1,NA
      DO 130 L=1,4
      IL=4*(I-1)+L
      AR(IL,IL)=EI(L,I)
  130 CONTINUE
  120 CONTINUE

      DO 140 I=1,NA
      ME=NN(I)
      DO 150 J=1,ME
      IK=IP(J,I)
      IF(IK.GT.I) GO TO 150
      RK=XK*DX(J,I)+YK*DY(J,I)+ZK*DZ(J,I)
C     C1=DCMPLX(0.0D0,RK)
C     CE=CDEXP(C1)
Cray
      C1=CMPLX(0.0D0,RK)
      CE=EXP(C1)
Cray
      DO 160 L=1,4
      DO 170 K=1,4
      IL=4*(I-1)+L
      JK=4*(IK-1)+K
      IF(JK.GT.IL) GO TO 170
      C2=CE*HM(K,L,J,I)
      IF(JK.EQ.IL) GO TO 180

c      print *,il,jk
Cray
      AI(IL,JK)=AI(IL,JK)+ IMAG(C2)
      AI(JK,IL)=AI(JK,IL)- IMAG(C2)
Cray
C     AI(IL,JK)=AI(IL,JK)+DIMAG(C2)
C     AI(JK,IL)=AI(JK,IL)-DIMAG(C2)
      AR(IL,JK)=AR(IL,JK)+DREAL(C2)
  180 AR(JK,IL)=AR(JK,IL)+DREAL(C2)
  170 CONTINUE
  160 CONTINUE
  150 CONTINUE
  140 CONTINUE
      RETURN
      END
