      subroutine calc_sr(na,man,dx,dy,dz,para,ip,nn,rs,r,s,g,xi
     &     ,sdx,sdy,sdz,rdx,rdy,rdz,xidx,xidy,xidz
     &     ,gdx,gdy,gdz
     &     )
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      dimension dx(man,na),dy(man,na),dz(man,na)
      dimension para(7,8)
      dimension ip(man,na),nn(na)
      dimension xi(7,man,na),s(7,man,na),g(na),r(6,man,na)
      dimension xidx(7,na,man,na),xidy(7,na,man,na),xidz(7,na,man,na)
      dimension sdx(7,na,man,na),sdy(7,na,man,na),sdz(7,na,man,na)
      dimension rdx(6,na,man,na),rdy(6,na,man,na),rdz(6,na,man,na)
      dimension gdx(na,na),gdy(na,na),gdz(na,na)

      do i=1,na
         do j=1,man
            do k=1,6
               xi(k,j,i)=0.0d0
               s(k,j,i)=0.0d0
               r(k,j,i)=0.0d0
            enddo

            xi(7,j,i)=0.0d0
            s(7,j,i)=0.0d0
         enddo
      enddo
c-----------------------------------
      do i=1,na
         do j=1,na
            gdx(j,i)=0.0d0
            gdy(j,i)=0.0d0
            gdz(j,i)=0.0d0
            do k=1,man
               do l=1,6
                  xidx(l,j,k,i)=0.0d0
                  xidy(l,j,k,i)=0.0d0
                  xidz(l,j,k,i)=0.0d0
                  sdx(l,j,k,i)=0.0d0
                  sdy(l,j,k,i)=0.0d0
                  sdz(l,j,k,i)=0.0d0
                  rdx(l,j,k,i)=0.0d0
                  rdy(l,j,k,i)=0.0d0
                  rdz(l,j,k,i)=0.0d0
               enddo
               xidx(7,j,k,i)=0.0d0
               xidy(7,j,k,i)=0.0d0
               xidz(7,j,k,i)=0.0d0
               sdx(7,j,k,i)=0.0d0
               sdy(7,j,k,i)=0.0d0
               sdz(7,j,k,i)=0.0d0
            enddo
         enddo
      enddo
c---------------------------               
                 

c-----CALCULATING S_ij & R_ij-------------------------------

c-----XI_ij
      do 101 i=1,na
         ni=nn(i)
         do 102 k=1,ni
            numk=ip(k,i)
            do 103 j=1,ni
               numj=ip(j,i)
               if(k.ne.j) then
                  rik=dsqrt(dx(k,i)**2+dy(k,i)**2+dz(k,i)**2)
                  rij=dsqrt(dx(j,i)**2+dy(j,i)**2+dz(j,i)**2)
                  xjk=dx(k,i)-dx(j,i)
                  yjk=dy(k,i)-dy(j,i)
                  zjk=dz(k,i)-dz(j,i)
                  rjk=dsqrt(xjk**2+yjk**2+zjk**2)
c---------differencials-------------------------------------------
                  if(rjk.lt.rs) then
                     do kk=1,7
                        xi(kk,j,i)=xi(kk,j,i)+
     &                       para(kk,5)*dexp(-para(kk,6)*
     &                       ((rik+rjk)/rij)**para(kk,7))
                        dtmp1=para(kk,5)*dexp(-para(kk,6)*
     &                       ((rik+rjk)/rij)**para(kk,7))
                        dtmp2=(-para(kk,6)*para(kk,7))*
     &     (((rik+rjk)/rij)**(para(kk,7)-1.0d0))
                        do idif=1,na
                           drikdx=0.0d0
                           drikdy=0.0d0
                           drikdz=0.0d0
                           drijdx=0.0d0
                           drijdy=0.0d0
                           drijdz=0.0d0
                           drjkdx=0.0d0
                           drjkdy=0.0d0
                           drjkdz=0.0d0
                           if(idif.eq.i) then
                              drikdx=-dx(k,i)/rik
                              drikdy=-dy(k,i)/rik
                              drikdz=-dz(k,i)/rik
                              drijdx=-dx(j,i)/rij
                              drijdy=-dy(j,i)/rij
                              drijdz=-dz(j,i)/rij
                           endif
                           if(idif.eq.numk) then
                              drikdx=dx(k,i)/rik
                              drikdy=dy(k,i)/rik
                              drikdz=dz(k,i)/rik
                              drjkdx=xjk/rjk
                              drjkdy=yjk/rjk
                              drjkdz=zjk/rjk
                           endif
                           if(idif.eq.numj) then
                              drijdx=dx(j,i)/rij
                              drijdy=dy(j,i)/rij
                              drijdz=dz(j,i)/rij
                              drjkdx=-xjk/rjk
                              drjkdy=-yjk/rjk
                              drjkdz=-zjk/rjk
                           endif
                           if(i.eq.numk) then
                              drikdx=0.0d0
                              drikdy=0.0d0
                              drikdz=0.0d0
                           endif
                           if(i.eq.numj) then
                              drijdx=0.0d0
                              drijdy=0.0d0
                              drijdz=0.0d0
                           endif
                           if(numk.eq.numj) then
                              drjkdx=0.0d0
                              drjkdy=0.0d0
                              drjkdz=0.0d0
                           endif
c-----------
                           xidx(kk,idif,j,i)=xidx(kk,idif,j,i)+
     &     dtmp1*dtmp2*((drikdx+drjkdx)*rij-(rik+rjk)*drijdx)/rij**2
                           xidy(kk,idif,j,i)=xidy(kk,idif,j,i)+
     &     dtmp1*dtmp2*((drikdy+drjkdy)*rij-(rik+rjk)*drijdy)/rij**2
                           xidz(kk,idif,j,i)=xidz(kk,idif,j,i)+
     &     dtmp1*dtmp2*((drikdz+drjkdz)*rij-(rik+rjk)*drijdz)/rij**2
c----------
                        enddo
                     enddo
                  endif
               endif
 103        enddo
 102     enddo
 101  enddo

c     do j=1,nn(1)
c         print *, xi(7,j,1),j
c      enddo
c-----S_ij & g_ij

      do i=1,na
         g(i)=0.0d0
         ni=nn(i)
         do j=1,ni
            do kk=1,7
               tmp=dtanh(xi(kk,j,i))
               tmp2=tmp**2
               s(kk,j,i)=tmp
c------
               do k=1,na
                  sdx(kk,k,j,i)=(1-tmp2)*xidx(kk,k,j,i)
                  sdy(kk,k,j,i)=(1-tmp2)*xidy(kk,k,j,i)
                  sdz(kk,k,j,i)=(1-tmp2)*xidz(kk,k,j,i)
               enddo
c-------
            enddo
            g(i)=g(i)+1.0d0-s(7,j,i)
c-----
            do k=1,na
               gdx(k,i)=gdx(k,i)-sdx(7,k,j,i)
               gdy(k,i)=gdy(k,i)-sdy(7,k,j,i)
               gdz(k,i)=gdz(k,i)-sdz(7,k,j,i)
            enddo
c-------
         enddo
c         g(i)=0.33492347d1
      enddo
cc      if(ks.eq.1) then
c         do i=1,na
c            print '(1x,d16.8)', g(i)
ccc            g(i)=3.3d0
c         enddo
c      endif

c-----R_ij
      do kk=1,6
         do i=1,na
            ni=nn(i)
            do j=1,ni
               ik=ip(j,i)
               rij=dsqrt(dx(j,i)**2+dy(j,i)**2+dz(j,i)**2)
               r(kk,j,i)=rij*(1.0d0+para(kk,8)/2.0d0*
     &              ((g(i)-4.0d0)/4.0d0+(g(ik)-4.0d0)/4.0d0))
               do k=1,na
                  drijdx=0.0d0
                  drijdy=0.0d0
                  drijdz=0.0d0
                  if(k.eq.i) then
                     drijdx=-dx(j,i)/rij
                     drijdy=-dy(j,i)/rij
                     drijdz=-dz(j,i)/rij
                  endif
                  if(k.eq.ik) then
                     drijdx=dx(j,i)/rij
                     drijdy=dy(j,i)/rij
                     drijdz=dz(j,i)/rij
                  endif
                  if(ik.eq.i) then
                     drijdx=0.0d0
                     drijdy=0.0d0
                     drijdz=0.0d0
                  endif
c------------
                  rdx(kk,k,j,i)=drijdx*r(kk,j,i)/rij
     &                 +rij*para(kk,8)/2.0d0/4.0d0
     &                 *(gdx(k,i)+gdx(k,ik))
                  rdy(kk,k,j,i)=drijdy*r(kk,j,i)/rij
     &                 +rij*para(kk,8)/2.0d0/4.0d0
     &                 *(gdy(k,i)+gdy(k,ik))
                  rdz(kk,k,j,i)=drijdz*r(kk,j,i)/rij
     &                 +rij*para(kk,8)/2.0d0/4.0d0
     &                 *(gdz(k,i)+gdz(k,ik))
c--------------
               enddo
            enddo
         enddo
      enddo
      
      return
      end
