subroutine const_hs_bsSiC(ks)
  use variables
  use parambsSiC
  implicit double precision(a,b,d-h,o-z),integer(i-n),complex*16(c)
  double precision :: hmm(9,9),smm(9,9), &
       hmx(9,9),hmy(9,9),hmz(9,9),smx(9,9),smy(9,9),smz(9,9)
  nm=mm

!c-----Si-parameter-------------------------------------------
!c      call para_si(rum,as,bs,gs,rcs,aq,bp,gp,rcp,ro,rlo, &
!c                  asss,bsss,esss,dsss,asps,bsps,esps,dsps, &
!c                  apps,bpps,epps,dpps,appp,bppp,eppp,dppp, &
!c                  psss,qsss,rsss,ssss,psps,qsps,rsps,ssps, &
!c                  ppps,qpps,rpps,spps,pppp,qppp,rppp,sppp)
!c      go to 9000
!cc-----C-parameter--------------------------------------------
!  call para_c_bsSiC(rum,as,bs,gs,rcs,aq,bp,gp,rcp,ro,rlo, &
!       asss,bsss,esss,dsss,asps,bsps,esps,dsps, &
!       apps,bpps,epps,dpps,appp,bppp,eppp,dppp, &
!       psss,qsss,rsss,ssss,psps,qsps,rsps,ssps, &
!       ppps,qpps,rpps,spps,pppp,qppp,rppp,sppp)
!cc------------------------------------------------------------      

!9000 continue


  do i=1,nm
     do j=1,nm
        ar(i,j)=0.0d0
        ai(i,j)=0.0d0
        sr(i,j)=0.0d0
        si(i,j)=0.0d0
     enddo
  enddo

  do i=1,na
     do j=1,na
        do jj=1,2
           drhox2(i,j,jj)=0.0d0
           drhoy2(i,j,jj)=0.0d0
           drhoz2(i,j,jj)=0.0d0
        enddo
     enddo
  enddo

  ! calc rho
  do i=1,na
     rho(i,1)=0.0d0; rho(i,2)=0.0d0 !1:C, 2:Si
     ni=nn(i)
     do j=1,ni
        ik=ip(j,i)
        rx=dx(j,i); ry=dy(j,i); rz=dz(j,i)
        r2=rx*rx+ry*ry+rz*rz; rr=sqrt(r2)
!        fff=1.0d0/(1.0d0+dexp((rr-ro)/rlo)) !PRB54-4519(1996)
        fff=1.0d0/(1.0d0+dexp((rr-ro)/rlo+5.0d0)) !PRB62-4478(2000)
        dff=dexp((rr-ro)/rlo+5.0d0)/rlo
        jj=0; if (spc(ik)==6) jj=1; if (spc(ik)==14) jj=2; if (jj==0) stop 'jj=0'
        xlam2=lambda(jj)**2
        rho(i,jj)=rho(i,jj)+exp(-xlam2)*rr*fff

        rll=rx/rr; rmm=ry/rr; rnn=rz/rr
        rk=xs(ks)*rx+ys(ks)*ry+zs(ks)*rz
        cc=dcmplx(0.0d0,rk)
        ce=cdexp(cc)

!        vss=(asss+bsss*rr+esss*r2)*dexp(-dsss*dsss*rr)*fff
!        vsp=(asps+bsps*rr+esps*r2)*dexp(-dsps*dsps*rr)*fff
!        vpps=(apps+bpps*rr+epps*r2)*dexp(-dpps*dpps*rr)*fff
!        vppp=(appp+bppp*rr+eppp*r2)*dexp(-dppp*dppp*rr)*fff
!        oss=(1.0d0+psss*rr+qsss*r2+rsss*r2*rr)*dexp(-ssss*ssss*rr)*fff
!        osp=(psps*rr+qsps*r2+rsps*r2*rr)*dexp(-ssps*ssps*rr)*fff
!        opps=(1.0d0+ppps*rr+qpps*r2+rpps*r2*rr)*dexp(-spps*spps*rr)*fff
!        oppp=(1.0d0+pppp*rr+qppp*r2+rppp*r2*rr)*dexp(-sppp*sppp*rr)*fff
        
        if(ik.ne.i) then
           drhox2(i,i,jj)=drhox2(i,i,jj) &
                +(xlam2+fff*dff)*dexp(-xlam2*rr)*fff*rll
           drhoy2(i,i,jj)=drhoy2(i,i,jj) &
                +(xlam2+fff*dff)*dexp(-xlam2*rr)*fff*rmm
           drhoz2(i,i,jj)=drhoz2(i,i,jj) &
                +(xlam2+fff*dff)*dexp(-xlam2*rr)*fff*rnn

           drhox2(i,ik,jj)=drhox2(i,ik,jj) &
                -(xlam2+fff*dff)*dexp(-xlam2*rr)*fff*rll
           drhoy2(i,ik,jj)=drhoy2(i,ik,jj) &
                -(xlam2+fff*dff)*dexp(-xlam2*rr)*fff*rmm
           drhoz2(i,ik,jj)=drhoz2(i,ik,jj) &
                -(xlam2+fff*dff)*dexp(-xlam2*rr)*fff*rnn
        endif
     enddo
  enddo ! end of calc rho

  do i=1,na
     ni=nn(i)
     ii=0; if (spc(i)==6) ii=1; if (spc(i)==14) ii=2; if (ii==0) stop 'ii=0' 
     do j=1,ni
        ik=ip(j,i)
        rx=dx(j,i); ry=dy(j,i); rz=dz(j,i)
        r2=rx*rx+ry*ry+rz*rz; rr=sqrt(r2); r3=r2*rr
!        fff=1.0d0/(1.0d0+dexp((rr-ro)/rlo)) !PRB54-4519(1996)
        fff=1.0d0/(1.0d0+dexp((rr-ro)/rlo+5.0d0)) !PRB62-4478(2000)
        dff=dexp((rr-ro)/rlo+5.0d0)/rlo
        jj=0; if (spc(ik)==6) jj=1; if (spc(ik)==14) jj=2; if (jj==0) stop 'jj=0'
        if (ii/=jj) then !1:C, 2:Si, 3:C-Si
           ij=3
        else if (ii==1) then
           ij=1
        else
           ij=2
        endif

        xlam2=lambda(jj)**2
        rll=rx/rr; rmm=ry/rr; rnn=rz/rr
        rk=xs(ks)*rx+ys(ks)*ry+zs(ks)*rz
        cc=dcmplx(0.0d0,rk)
        ce=cdexp(cc)

        !a,b,e,g = e,f,fbar,g
        vsss=(asss(ij)+bsss(ij)*rr+esss(ij)*r2)*exp(-gsss(ij)**2*rr)*fff
        vsps=(asps(ij)+bsps(ij)*rr+esps(ij)*r2)*exp(-gsps(ij)**2*rr)*fff
        vpps=(apps(ij)+bpps(ij)*rr+epps(ij)*r2)*exp(-gpps(ij)**2*rr)*fff
        vppp=(appp(ij)+bppp(ij)*rr+eppp(ij)*r2)*exp(-gppp(ij)**2*rr)*fff
        vsds=(asds(ij)+bsds(ij)*rr+esds(ij)*r2)*exp(-gsds(ij)**2*rr)*fff
        vpds=(apds(ij)+bpds(ij)*rr+epds(ij)*r2)*exp(-gpds(ij)**2*rr)*fff
        vpdp=(apdp(ij)+bpdp(ij)*rr+epdp(ij)*r2)*exp(-gpdp(ij)**2*rr)*fff
        vdds=(adds(ij)+bdds(ij)*rr+edds(ij)*r2)*exp(-gdds(ij)**2*rr)*fff
        vddp=(addp(ij)+bddp(ij)*rr+eddp(ij)*r2)*exp(-gddp(ij)**2*rr)*fff
        vddd=(addd(ij)+bddd(ij)*rr+eddd(ij)*r2)*exp(-gddd(ij)**2*rr)*fff
        !t,q,r,u = e,f,fbar,g
        osss=(1.0d0+tsss(ij)*rr+qsss(ij)*r2+rsss(ij)*r3)*exp(-usss(ij)**2*rr)*fff
        osps=(      tsps(ij)*rr+qsps(ij)*r2+rsps(ij)*r3)*exp(-usps(ij)**2*rr)*fff
        opps=(1.0d0+tpps(ij)*rr+qpps(ij)*r2+rpps(ij)*r3)*exp(-upps(ij)**2*rr)*fff
        oppp=(1.0d0+tppp(ij)*rr+qppp(ij)*r2+rppp(ij)*r3)*exp(-uppp(ij)**2*rr)*fff
        osds=(      tsds(ij)*rr+qsds(ij)*r2+rsds(ij)*r3)*exp(-usds(ij)**2*rr)*fff
        opds=(      tpds(ij)*rr+qpds(ij)*r2+rpds(ij)*r3)*exp(-upds(ij)**2*rr)*fff
        opdp=(      tpdp(ij)*rr+qpdp(ij)*r2+rpdp(ij)*r3)*exp(-updp(ij)**2*rr)*fff
        odds=(1.0d0+tdds(ij)*rr+qdds(ij)*r2+rdds(ij)*r3)*exp(-udds(ij)**2*rr)*fff
        oddp=(1.0d0+tddp(ij)*rr+qddp(ij)*r2+rddp(ij)*r3)*exp(-uddp(ij)**2*rr)*fff
        oddd=(1.0d0+tddd(ij)*rr+qddd(ij)*r2+rddd(ij)*r3)*exp(-uddd(ij)**2*rr)*fff
        call set_hmm(hmm,rll,rmm,rnn,vsss,vsps,vpps,vppp,vsds,vpds,vpdp,vdds,vddp,vddd)
        call set_hmm(smm,rll,rmm,rnn,osss,osps,opps,oppp,osds,opds,opdp,odds,oddp,oddd)
        
!C                                         
!C     DERIVATIVES OF TWO-CENTER PARAMETERS
!C                                         

        if (ik.ne.i) then
           dvsss=(bsss(ij)+2.0d0*esss(ij)*rr)*exp(-gsss(ij)**2*rr)*fff-gsss(ij)**2*vsss
           dvsps=(bsps(ij)+2.0d0*esps(ij)*rr)*exp(-gsps(ij)**2*rr)*fff-gsps(ij)**2*vsps
           dvpps=(bpps(ij)+2.0d0*epps(ij)*rr)*exp(-gpps(ij)**2*rr)*fff-gpps(ij)**2*vpps
           dvppp=(bppp(ij)+2.0d0*eppp(ij)*rr)*exp(-gppp(ij)**2*rr)*fff-gppp(ij)**2*vppp
           dvsds=(bsds(ij)+2.0d0*esds(ij)*rr)*exp(-gsds(ij)**2*rr)*fff-gsds(ij)**2*vsds
           dvpds=(bpds(ij)+2.0d0*epds(ij)*rr)*exp(-gpds(ij)**2*rr)*fff-gpds(ij)**2*vpds
           dvpdp=(bpdp(ij)+2.0d0*epdp(ij)*rr)*exp(-gpdp(ij)**2*rr)*fff-gpdp(ij)**2*vpdp
           dvdds=(bdds(ij)+2.0d0*edds(ij)*rr)*exp(-gdds(ij)**2*rr)*fff-gdds(ij)**2*vdds
           dvddp=(bddp(ij)+2.0d0*eddp(ij)*rr)*exp(-gddp(ij)**2*rr)*fff-gddp(ij)**2*vddp
           dvddd=(bddd(ij)+2.0d0*eddd(ij)*rr)*exp(-gddd(ij)**2*rr)*fff-gddd(ij)**2*vddd
           osss=(tsss(ij)+2.0d0*qsss(ij)*rr+3.0d0*rsss(ij)*r2)*exp(-usss(ij)**2*rr)*fff &
                -usss(ij)**2*osss
           osps=(tsps(ij)+2.0d0*qsps(ij)*rr+3.0d0*rsps(ij)*r2)*exp(-usps(ij)**2*rr)*fff &
                -usps(ij)**2*osps
           opps=(tpps(ij)+2.0d0*qpps(ij)*rr+3.0d0*rpps(ij)*r2)*exp(-upps(ij)**2*rr)*fff &
                -upps(ij)**2*opps
           oppp=(tppp(ij)+2.0d0*qppp(ij)*rr+3.0d0*rppp(ij)*r2)*exp(-uppp(ij)**2*rr)*fff &
                -uppp(ij)**2*oppp
           osds=(tsds(ij)+2.0d0*qsds(ij)*rr+3.0d0*rsds(ij)*r2)*exp(-usds(ij)**2*rr)*fff &
                -usds(ij)**2*osds
           opds=(tpds(ij)+2.0d0*qpds(ij)*rr+3.0d0*rpds(ij)*r2)*exp(-upds(ij)**2*rr)*fff &
                -upds(ij)**2*opds
           opdp=(tpdp(ij)+2.0d0*qpdp(ij)*rr+3.0d0*rpdp(ij)*r2)*exp(-updp(ij)**2*rr)*fff &
                -updp(ij)**2*opdp
           odds=(tdds(ij)+2.0d0*qdds(ij)*rr+3.0d0*rdds(ij)*r2)*exp(-udds(ij)**2*rr)*fff &
                -udds(ij)**2*odds
           oddp=(tddp(ij)+2.0d0*qddp(ij)*rr+3.0d0*rddp(ij)*r2)*exp(-uddp(ij)**2*rr)*fff &
                -uddp(ij)**2*oddp
           oddd=(tddd(ij)+2.0d0*qddd(ij)*rr+3.0d0*rddd(ij)*r2)*exp(-uddd(ij)**2*rr)*fff &
                -uddd(ij)**2*oddd
           if (dff /= 0.0) then
              dvsss=dvsss+vsss/fff*dff
              dvsps=dvsps+vsps/fff*dff
              dvpps=dvpps+vpps/fff*dff
              dvppp=dvppp+vppp/fff*dff
              dvsds=dvsds+vsds/fff*dff
              dvpds=dvpds+vpds/fff*dff
              dvpdp=dvpdp+vpdp/fff*dff
              dvdds=dvdds+vdds/fff*dff
              dvddp=dvddp+vddp/fff*dff
              dvddd=dvddd+vddd/fff*dff
              dosss=dosss+osss/fff*dff
              dosps=dosps+osps/fff*dff
              dopps=dopps+opps/fff*dff
              doppp=doppp+oppp/fff*dff
              dosds=dosds+osds/fff*dff
              dopds=dopds+opds/fff*dff
              dopdp=dopdp+opdp/fff*dff
              dodds=dodds+odds/fff*dff
              doddp=doddp+oddp/fff*dff
              doddd=doddd+oddd/fff*dff
           endif
        call set_dhmm(hmx,hmy,hmz,rr,r2,r3,rll,rmm,rnn &
             ,vsss,vsps,vpps,vppp,vsds,vpds,vpdp,vdds,vddp,vddd &
             ,dvsss,dvsps,dvpps,dvppp,dvsds,dvpds,dvpdp,dvdds,dvddp,dvddd)
!c------Hamiltonian----------------------------------------
!           ds1=bsss+2.0d0*esss*rr  
!           ds2=bsps+2.0d0*esps*rr 
!           ds3=bpps+2.0d0*epps*rr 
!           ds4=bppp+2.0d0*eppp*rr 

!           ddss=(ds1*dexp(-dsss**2*rr)-vss*dff)*fff-dsss*dsss*vss      
!           ddsp=(ds2*dexp(-dsps**2*rr)-vsp*dff)*fff-dsps*dsps*vsp       
!           ddpps=(ds3*dexp(-dpps**2*rr)-vpps*dff)*fff-dpps*dpps*vpps    
!           ddppp=(ds4*dexp(-dppp**2*rr)-vppp*dff)*fff-dppp*dppp*vppp            

!           hmx(1,1)=-rll*ddss; hmy(1,1)=-rmm*ddss; hmz(1,1)=-rnn*ddss 
!           v1=-vsp/rr+ddsp            
!           hmx(1,2)=-vsp/rr-rll**2*v1
!           hmy(1,2)=-rll*rmm*v1
!           hmz(1,2)=-rll*rnn*v1      
!           hmx(1,3)=-rll*rmm*v1      
!           hmy(1,3)=-vsp/rr-rmm**2*v1
!           hmz(1,3)=-rmm*rnn*v1      
!           hmx(1,4)=-rll*rnn*v1      
!           hmy(1,4)=-rmm*rnn*v1      
!           hmz(1,4)=-vsp/rr-rnn**2*v1
!           hmx(2,1)=-hmx(1,2); hmy(2,1)=-hmy(1,2); hmz(2,1)=-hmz(1,2)        
!           hmx(3,1)=-hmx(1,3); hmy(3,1)=-hmy(1,3); hmz(3,1)=-hmz(1,3)        
!           hmx(4,1)=-hmx(1,4); hmy(4,1)=-hmy(1,4); hmz(4,1)=-hmz(1,4)        
!           v2=vpps-vppp              
!           hmx(2,2)=-2.0d0*rll*(1.0d0-rll**2)/rr*v2-rll**3*ddpps &
!                -rll*(1.0d0-rll**2)*ddppp   
!           hmy(2,2)=2.0d0*rll**2*rmm/rr*v2-rll**2*rmm*ddpps &
!                -rmm*(1.0d0-rll**2)*ddppp     
!           hmz(2,2)=2.0d0*rll**2*rnn/rr*v2-rll**2*rnn*ddpps &
!                -rnn*(1.0d0-rll**2)*ddppp        
!           hmx(3,3)=2.0d0*rll*rmm**2/rr*v2-rll*rmm**2*ddpps &
!                -rll*(1.0d0-rmm**2)*ddppp       
!           hmy(3,3)=-2.0d0*rmm*(1.0d0-rmm**2)/rr*v2-rmm**3*ddpps &
!                -rmm*(1.0d0-rmm**2)*ddppp              
!           hmz(3,3)=2.0d0*rmm**2*rnn/rr*v2-rnn*rmm**2*ddpps &
!                -rnn*(1.0d0-rmm**2)*ddppp   
!           hmx(4,4)=2.0d0*rll*rnn**2/rr*v2-rll*rnn**2*ddpps &
!                -rll*(1.0d0-rnn**2)*ddppp      
!           hmy(4,4)=2.0d0*rmm*rnn**2/rr*v2-rmm*rnn**2*ddpps &
!                -rmm*(1.0d0-rnn**2)*ddppp       
!           hmz(4,4)=-2.0d0*rnn*(1.0d0-rnn**2)/rr*v2-rnn**3*ddpps &
!                -rnn*(1.0d0-rnn**2)*ddppp        
!           v3=ddpps-ddppp                                        
!           hmx(2,3)=-rmm*(1.0d0-2.0d0*rll**2)/rr*v2-rll**2*rmm*v3 
!           hmy(2,3)=-rll*(1.0d0-2.0d0*rmm**2)/rr*v2-rll*rmm**2*v3 
!           hmz(2,3)=2.0d0*rll*rmm*rnn/rr*v2-rll*rmm*rnn*v3        
!           hmx(3,2)=hmx(2,3); hmy(3,2)=hmy(2,3); hmz(3,2)=hmz(2,3)
!           hmx(3,4)=2.0d0*rll*rmm*rnn/rr*v2-rll*rmm*rnn*v3        
!           hmy(3,4)=-rnn*(1.0d0-2.0d0*rmm**2)/rr*v2-rmm**2*rnn*v3 
!           hmz(3,4)=-rmm*(1.0d0-2.0d0*rnn**2)/rr*v2-rmm*rnn**2*v3 
!           hmx(4,3)=hmx(3,4); hmy(4,3)=hmy(3,4); hmz(4,3)=hmz(3,4)
!           hmx(2,4)=-rnn*(1.0d0-2.0d0*rll**2)/rr*v2-rnn*rll**2*v3 
!           hmy(2,4)=2.0d0*rll*rmm*rnn/rr*v2-rll*rmm*rnn*v3        
!           hmz(2,4)=-rll*(1.0d0-2.0d0*rnn**2)/rr*v2-rll*rnn**2*v3 
!           hmx(4,2)=hmx(2,4); hmy(4,2)=hmy(2,4); hmz(4,2)=hmz(2,4)
!c-----Overlap-----------------------------------------------                
!           ds1=psss+2.0d0*qsss*rr+3.0d0*rsss*r2 
!           ds2=psps+2.0d0*qsps*rr+3.0d0*rsps*r2
!           ds3=ppps+2.0d0*qpps*rr+3.0d0*rpps*r2
!           ds4=pppp+2.0d0*qppp*rr+3.0d0*rppp*r2
!           ddss=(ds1*dexp(-ssss*ssss*rr)-oss*dff)*fff-ssss*ssss*oss      
!            ddsp=(ds2*dexp(-ssps*ssps*rr)-osp*dff)*fff-ssps*ssps*osp       
!            ddpps=(ds3*dexp(-spps*spps*rr)-opps*dff)*fff-spps*spps*opps    
!            ddppp=(ds4*dexp(-sppp*sppp*rr)-oppp*dff)*fff-sppp*sppp*oppp  


 !           smx(1,1)=-rll*ddss 
 !           smy(1,1)=-rmm*ddss 
 !           smz(1,1)=-rnn*ddss 
 !           v1=-osp/rr+ddsp            
 !           smx(1,2)=-osp/rr-rll**2*v1
 !           smy(1,2)=-rll*rmm*v1      
 !           smz(1,2)=-rll*rnn*v1      
 !           smx(1,3)=-rll*rmm*v1      
 !           smy(1,3)=-osp/rr-rmm**2*v1
 !           smz(1,3)=-rmm*rnn*v1      
 !           smx(1,4)=-rll*rnn*v1      
 !           smy(1,4)=-rmm*rnn*v1      
 !           smz(1,4)=-osp/rr-rnn**2*v1
 !           smx(2,1)=-smx(1,2)        
 !           smy(2,1)=-smy(1,2)        
 !           smz(2,1)=-smz(1,2)        
 !           smx(3,1)=-smx(1,3)        
 !           smy(3,1)=-smy(1,3)        
 !           smz(3,1)=-smz(1,3)        
 !           smx(4,1)=-smx(1,4)        
 !           smy(4,1)=-smy(1,4)        
 !           smz(4,1)=-smz(1,4)        
 !           v2=opps-oppp 
 !           smx(2,2)=-2.0d0*rll*(1.0d0-rll**2)/rr*v2-rll**3*ddpps &
 !                -rll*(1.0d0-rll**2)*ddppp  
 !           smy(2,2)=2.0d0*rll**2*rmm/rr*v2-rll**2*rmm*ddpps &
 !                -rmm*(1.0d0-rll**2)*ddppp 
 !           smz(2,2)=2.0d0*rll**2*rnn/rr*v2-rll**2*rnn*ddpps &
 !                -rnn*(1.0d0-rll**2)*ddppp
 !           smx(3,3)=2.0d0*rll*rmm**2/rr*v2-rll*rmm**2*ddpps &
 !                -rll*(1.0d0-rmm**2)*ddppp 
 !           smy(3,3)=-2.0d0*rmm*(1.0d0-rmm**2)/rr*v2-rmm**3*ddpps &
 !                -rmm*(1.0d0-rmm**2)*ddppp
 !           smz(3,3)=2.0d0*rmm**2*rnn/rr*v2-rnn*rmm**2*ddpps &
 !                -rnn*(1.0d0-rmm**2)*ddppp 
 !           smx(4,4)=2.0d0*rll*rnn**2/rr*v2-rll*rnn**2*ddpps &
 !                -rll*(1.0d0-rnn**2)*ddppp
 !           smy(4,4)=2.0d0*rmm*rnn**2/rr*v2-rmm*rnn**2*ddpps &
 !                -rmm*(1.0d0-rnn**2)*ddppp  
 !           smz(4,4)=-2.0d0*rnn*(1.0d0-rnn**2)/rr*v2-rnn**3*ddpps &
 !                -rnn*(1.0d0-rnn**2)*ddppp  
 !           v3=ddpps-ddppp                                        
 !           smx(2,3)=-rmm*(1.0d0-2.0d0*rll**2)/rr*v2-rll**2*rmm*v3 
 !           smy(2,3)=-rll*(1.0d0-2.0d0*rmm**2)/rr*v2-rll*rmm**2*v3 
 !           smz(2,3)=2.0d0*rll*rmm*rnn/rr*v2-rll*rmm*rnn*v3        
 !           smx(3,2)=smx(2,3)                                      
 !           smy(3,2)=smy(2,3)                                      
 !           smz(3,2)=smz(2,3)                                      
 !           smx(3,4)=2.0d0*rll*rmm*rnn/rr*v2-rll*rmm*rnn*v3        
 !           smy(3,4)=-rnn*(1.0d0-2.0d0*rmm**2)/rr*v2-rmm**2*rnn*v3 
 !           smz(3,4)=-rmm*(1.0d0-2.0d0*rnn**2)/rr*v2-rmm*rnn**2*v3 
 !           smx(4,3)=smx(3,4)                                      
 !           smy(4,3)=smy(3,4)                                      
 !           smz(4,3)=smz(3,4)                                      
 !           smx(2,4)=-rnn*(1.0d0-2.0d0*rll**2)/rr*v2-rnn*rll**2*v3 
 !           smy(2,4)=2.0d0*rll*rmm*rnn/rr*v2-rll*rmm*rnn*v3        
 !           smz(2,4)=-rll*(1.0d0-2.0d0*rnn**2)/rr*v2-rll*rnn**2*v3 
 !           smx(4,2)=smx(2,4)                                      
 !           smy(4,2)=smy(2,4)                                      
 !           smz(4,2)=smz(2,4)
!c---------------------------------------------------------------------
         endif

         do k=1,4
            do l=1,4
               ar((i-1)*4+k,(ik-1)*4+l)=ar((i-1)*4+k,(ik-1)*4+l)+dreal(hmm(k,l)*ce)
               ai((i-1)*4+k,(ik-1)*4+l)=ai((i-1)*4+k,(ik-1)*4+l)+dimag(hmm(k,l)*ce)
               sr((i-1)*4+k,(ik-1)*4+l)=sr((i-1)*4+k,(ik-1)*4+l)+dreal(smm(k,l)*ce)
               si((i-1)*4+k,(ik-1)*4+l)=si((i-1)*4+k,(ik-1)*4+l)+dimag(smm(k,l)*ce)
               if (ik.ne.i) then 
                  hdx(l,k,j,i)=hmx(k,l)
                  hdy(l,k,j,i)=hmy(k,l)
                  hdz(l,k,j,i)=hmz(k,l)
               
                  sdx(l,k,j,i)=smx(k,l) 
                  sdy(l,k,j,i)=smy(k,l)
                  sdz(l,k,j,i)=smz(k,l)  
               endif
            enddo
         enddo

      enddo
   enddo

!   do i=1,na
!      es(i)=as
!      ep(i)=aq
!      if (spc(i)==6) ii=1; if (spc(i)==14) ii=2
!      do jj=1,2
!         es(i)=es(i)+bs(ii,jj)*rho(i,jj)**(2.0d0/3.0d0) &
!              +gs(ii,jj)*rho(i,jj)**(4.0d0/3.0d0)+xs(ii,jj)*rho(i)**2
!         ep(i)=ep(i)+bp(ii,jj)*rho(i,jj)**(2.0d0/3.0d0) &
!              +gp(ii,jj)*rho(i,jj)**(4.0d0/3.0d0)+xp(ii,jj)*rho(i)**2
!      enddo
!      do j=1,na
!         desx(i,j)=0.0d0; desy(i,j)=0.0d0; desz(i,j)=0.0d0
!         depx(i,j)=0.0d0; depy(i,j)=0.0d0; depz(i,j)=0.0d0
!         do jj=1,2
!            xxx=2.0d0/3.0d0*bs(ii,jj)*rho(i,jj)**(-1.0d0/3.0d0) &
!                 +4.0d0/3.0d0*gs(ii,jj)*rho(i,jj)**(1.0d0/3.0d0) &
!                 +2.0d0*xs(ii,jj)*rho(i,jj)
!            desx(i,j)=desx(i,j)+xxx*drhox2(i,j,jj)
!            desy(i,j)=desy(i,j)+xxx*drhoy2(i,j,jj)
!            desz(i,j)=desz(i,j)+xxx*drhoz2(i,j,jj)
!            xxx=2.0d0/3.0d0*bp(ii,jj)*rho(i,jj)**(-1.0d0/3.0d0) &
!                 +4.0d0/3.0d0*gp(ii,jj)*rho(i,jj)**(1.0d0/3.0d0) &
!                 +2.0d0*xp(ii,jj)*rho(i,jj)
!            depx(i,j)=depx(i,j)+xxx*drhox2(i,j,jj)
!            depy(i,j)=depy(i,j)+xxx*drhoy2(i,j,jj)
!            depz(i,j)=depz(i,j)+xxx*drhoz2(i,j,jj)
!         enddo
!      enddo
!   enddo
   
   do i=1,na
      ar((i-1)*4+1,(i-1)*4+1)=ar((i-1)*4+1,(i-1)*4+1)+es(i)
      ar((i-1)*4+2,(i-1)*4+2)=ar((i-1)*4+2,(i-1)*4+2)+ep(i)
      ar((i-1)*4+3,(i-1)*4+3)=ar((i-1)*4+3,(i-1)*4+3)+ep(i)
      ar((i-1)*4+4,(i-1)*4+4)=ar((i-1)*4+4,(i-1)*4+4)+ep(i)
      
!c         sr((i-1)*4+1,(i-1)*4+1)=sr((i-1)*4+1,(i-1)*4+1)+es(i)
!c         sr((i-1)*4+2,(i-1)*4+2)=sr((i-1)*4+2,(i-1)*4+2)+ep(i)
!c         sr((i-1)*4+3,(i-1)*4+3)=sr((i-1)*4+3,(i-1)*4+3)+ep(i)
!c         sr((i-1)*4+4,(i-1)*4+4)=sr((i-1)*4+4,(i-1)*4+4)+ep(i)

      sr((i-1)*4+1,(i-1)*4+1)=sr((i-1)*4+1,(i-1)*4+1)+1.0d0
      sr((i-1)*4+2,(i-1)*4+2)=sr((i-1)*4+2,(i-1)*4+2)+1.0d0
      sr((i-1)*4+3,(i-1)*4+3)=sr((i-1)*4+3,(i-1)*4+3)+1.0d0
      sr((i-1)*4+4,(i-1)*4+4)=sr((i-1)*4+4,(i-1)*4+4)+1.0d0
   enddo
      

 end subroutine const_hs_bsSiC

 subroutine set_hmm(hmm,rll,rmm,rnn,vsss,vsps,vpps,vppp,vsds,vpds,vpdp,vdds,vddp,vddd)
   implicit none
   double precision :: hmm(9,9),vsss,vsps,vpps,vppp,vsds,vpds &
        ,vpdp,vdds,vddp,vddd
   double precision :: rll,rmm,rnn,sq3
   integer :: iii
   sq3=sqrt(3.0d0)
   hmm(1,1)=vsss !E_s,s
   hmm(1,2)=rll*vsps !E_s,x
   hmm(1,3)=rmm*vsps !E_s,y
   hmm(1,4)=rnn*vsps !E_s,z
   hmm(2,2)=rll**2*vpps+(1.0d0-rll**2)*vppp !E_x,x
   hmm(2,3)=rll*rmm*(vpps-vppp) !E_x,y
   hmm(2,4)=rll*rnn*(vpps-vppp) !E_x,z
   hmm(3,3)=rmm**2*vpps+(1.0d0-rmm**2)*vppp !E_y,y
   hmm(3,4)=rmm*rnn*(vpps-vppp) !E_y,z
   hmm(4,4)=rnn**2*vpps+(1.0d0-rnn**2)*vppp !E_z,z
   hmm(2,1)=-hmm(1,2)
   hmm(3,1)=-hmm(1,3)
   hmm(4,1)=-hmm(1,4)
   hmm(3,2)=hmm(2,3)
   hmm(4,2)=hmm(2,4)
   hmm(4,3)=hmm(3,4)
   hmm(1,5)=sq3*rll*rmm*vsds !E_s,dx
   hmm(1,6)=sq3*rmm*rnn*vsds !E_s,dy
   hmm(1,7)=sq3*rnn*rll*vsds !E_s,dz
   hmm(1,8)=sq3/2.0d0*(rll**2-rmm**2)*vsds !E_s,d(x^2-y^2)
   hmm(1,9)=(rnn**2-0.5d0*(rll**2+rmm**2))*vsds !E_s,d(3z^2-r^2)
   do iii=5,9
      hmm(iii,1)=hmm(1,iii)
   enddo
   hmm(2,5)=rmm*(vpdp+rll**2*(sq3*vpds-2.0d0*vpdp))
   hmm(2,6)=rll*rmm*rnn*(sq3*vpds-2.0d0*vpdp)
   hmm(2,7)=rnn*(vpdp+rll**2*(sq3*vpds-2.0d0*vpdp))
   hmm(2,8)=rll*(vpdp+0.5d0*(rll**2-rmm**2)*(sq3*vpds-2.0d0*vpdp))
   hmm(2,9)=1.0d0/sq3*rll &
        *(0.5d0*(3.0d0*rnn**2-1.0d0)*(sq3*vpds-2.0d0*vpdp)-vpdp)
   do iii=5,9
      hmm(iii,2)=-hmm(2,iii)
   enddo
   hmm(3,5)=rll*(vpdp+rmm**2*(sq3*vpds-2.0d0*vpdp))
   hmm(3,6)=rnn*(vpdp+rmm**2*(sq3*vpds-2.0d0*vpdp))
   hmm(3,7)=rll*rmm*rnn*(sq3*vpds-2.0d0*vpdp)
   hmm(3,8)=rmm*(-vpdp+0.5d0*(rll**2-rmm**2)*(sq3*vpds-2.0d0*vpdp))
   hmm(3,9)=1.0d0/sq3*rmm &
        *(0.5d0*(3.0d0*rnn**2-1.0d0)*(sq3*vpds-2.0d0*vpdp)-vpdp)
   do iii=5,9
      hmm(iii,3)=-hmm(3,iii)
   enddo
   hmm(4,5)=rll*rmm*rnn*(sq3*vpds-2.0d0*vpdp)
   hmm(4,6)=rmm*(vpdp+rnn**2*(sq3*vpds-2.0d0*vpdp))
   hmm(4,7)=rll*(vpdp+rnn**2*(sq3*vpds-2.0d0*vpdp))
   hmm(4,8)=rnn*(rll**2-rmm**2)*(sq3*vpds-2.0d0*vpdp)/2.0d0
   hmm(4,9)=0.5d0/sq3*rnn &
        *((3.0d0*rnn**2-1.0d0)*(sq3*vpds-2.0d0*vpdp)+4.0d0*vpdp)
   do iii=5,9
      hmm(iii,4)=-hmm(4,iii)
   enddo
   hmm(5,5)=(rll*rmm)**2*(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(rll**2+rmm**2)*(vddp-vddd)+vddd
   hmm(5,6)=rll*rnn*(rmm**2*(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(vddp-vddd))
   hmm(5,7)=rmm*rnn*(rll**2*(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(vddp-vddd))
   hmm(5,8)=0.5d0*rll*rmm*(rll**2-rmm**2) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)
   hmm(5,9)=0.5d0/sq3*rll*rmm*((3.0d0*rnn**2-1.0d0) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)-4.0d0*(vddp-vddd))
   do iii=6,9
      hmm(iii,5)=hmm(5,iii)
   enddo
   hmm(6,6)=(rmm*rnn)**2*(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(rmm**2+rnn**2)*(vddp-vddd)+vddd
   hmm(6,7)=rll*rmm*(rnn**2*(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(vddp-vddd))
   hmm(6,8)=rmm*rnn*(0.5d0*(rll**2-rmm**2) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)-(vddp-vddd))
   hmm(6,9)=0.5d0/sq3*rmm*rnn*((3.0d0*rnn**2-1.0d0) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)+2.0d0*(vddp-vddd))
   do iii=7,9
      hmm(iii,6)=hmm(6,iii)
   enddo
   hmm(7,7)=(rll*rnn)**2*(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(rll**2+rnn**2)*(vddp-vddd)+vddd
   hmm(7,8)=rll*rnn*(0.5d0*(rll**2-rmm*2) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)+(vddp-vddd))
   hmm(7,9)=0.5d0/sq3*rll*rnn*((3.0d0*rnn**2-1.0d0) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)+2.0d0*(vddp-vddd))
   do iii=8,9
      hmm(iii,7)=hmm(7,iii)
   enddo
   hmm(8,8)=0.25d0*(rll**2-rmm**2)**2 &
        *(3.0d0*vdds-4.0d0*vddp+vddd) &
        +(rll**2+rmm**2)*(vddp-vddd)+vddd
   hmm(8,9)=0.25d0/sq3*(rll**2-rmm**2)*((3.0d0*rnn**2-1.0d0) &
        *(3.0d0*vdds-4.0d0*vddp+vddd)-4.0d0*(vddp-vddd))
   hmm(9,8)=hmm(8,9)
   hmm(9,9)=1.0d0/12.0d0*(3.0d0*rnn**2-1.0d0)**2 &
        *(3.0d0*vdds-4.0d0*vddp+vddd) &
        +1.0d0/3.0d0*(3.0d0*rnn**2+1.0d0)*(vddp-vddd)+vddd
 end subroutine set_hmm

 subroutine set_dhmm(hmx,hmy,hmz,rr,r2,r3,rll,rmm,rnn &
      ,vsss,vsps,vpps,vppp,vsds,vpds,vpdp,vdds,vddp,vddd &
      ,dvsss,dvsps,dvpps,dvppp,dvsds,dvpds,dvpdp,dvdds,dvddp,dvddd)
   implicit none
   double precision :: hmx(9,9),hmy(9,9),hmz(9,9) &
        ,vsss,vsps,vpps,vppp,vsds,vpds,vpdp,vdds,vddp,vddd &
        ,dvsss,dvsps,dvpps,dvppp,dvsds,dvpds,dvpdp,dvdds,dvddp,dvddd &
        ,dvsssdx,dvppsdx,dvspsdx,dvpppdx,dvsdsdx,dvpdsdx,dvpdpdx,dvddsdx,dvddpdx,dvddddx &
        ,dvsssdy,dvppsdy,dvspsdy,dvpppdy,dvsdsdy,dvpdsdy,dvpdpdy,dvddsdy,dvddpdy,dvddddy &
        ,dvsssdz,dvppsdz,dvspsdz,dvpppdz,dvsdsdz,dvpdsdz,dvpdpdz,dvddsdz,dvddpdz,dvddddz
   double precision :: rll,rmm,rnn,sq3,rr,r2,r3
   double precision :: drlldx,drlldy,drlldz
   double precision :: drmmdx,drmmdy,drmmdz
   double precision :: drnndx,drnndy,drnndz
   sq3=sqrt(3.0d0)

   dvsssdx=-dvsss*rll; dvsssdy=-dvsss*rmm; dvsssdz=-dvsss*rnn
   dvspsdx=-dvsps*rll; dvspsdy=-dvsps*rmm; dvspsdz=-dvsps*rnn
   dvppsdx=-dvpps*rll; dvppsdy=-dvpps*rmm; dvppsdz=-dvpps*rnn
   dvpppdx=-dvppp*rll; dvpppdy=-dvppp*rmm; dvpppdz=-dvppp*rnn
   dvsdsdx=-dvsds*rll; dvsdsdy=-dvsds*rmm; dvsdsdz=-dvsds*rnn
   dvpdsdx=-dvpds*rll; dvpdsdy=-dvpds*rmm; dvpdsdz=-dvpds*rnn
   dvpdpdx=-dvpdp*rll; dvpdpdy=-dvpdp*rmm; dvpdpdz=-dvpdp*rnn
   dvddsdx=-dvdds*rll; dvddsdy=-dvdds*rmm; dvddsdz=-dvdds*rnn
   dvddpdx=-dvddp*rll; dvddpdy=-dvddp*rmm; dvddpdz=-dvddp*rnn
   dvddddx=-dvddd*rll; dvddddy=-dvddd*rmm; dvddddz=-dvddd*rnn
   drlldx=(rll**2-1.0d0)/rr
   drlldy=rll*rmm
   drlldz=rll*rnn
   drmmdx=rmm*rll
   drmmdy=(rmm**2-1.0d0)/rr
   drmmdz=rmm*rnn
   drnndx=rnn*rll
   drnndy=rnn*rmm
   drnndz=(rnn**2-1.0d0)/rr

   hmx(1,1)=dvsssdx
   hmy(1,1)=dvsssdy
   hmz(1,1)=dvsssdz
   hmx(1,2)=drlldx*vsps+rll*dvspsdx
   hmy(1,2)=drlldy*vsps+rll*dvspsdy
   hmz(1,2)=drlldz*vsps+rll*dvspsdz
   hmx(1,3)=drmmdx*vsps+rmm*dvspsdx
   hmy(1,3)=drmmdy*vsps+rmm*dvspsdy
   hmz(1,3)=drmmdz*vsps+rmm*dvspsdz
   hmx(1,4)=drnndx*vsps+rnn*dvspsdx
   hmy(1,4)=drnndy*vsps+rnn*dvspsdy
   hmz(1,4)=drnndz*vsps+rnn*dvspsdz
   hmx(2,2)=dvpppdx+2.0d0*rll*drlldx*(vpps-vppp)+rll**2*(dvppsdx-dvpppdx)
   hmy(2,2)=dvpppdy+2.0d0*rll*drlldy*(vpps-vppp)+rll**2*(dvppsdy-dvpppdy)
   hmz(2,2)=dvpppdz+2.0d0*rll*drlldz*(vpps-vppp)+rll**2*(dvppsdz-dvpppdz)
   hmx(2,3)=(drlldx*rmm+rll*drmmdx)*(vpps-vppp)+rll*rmm*(dvppsdx-dvpppdx)
   hmy(2,3)=(drlldy*rmm+rll*drmmdy)*(vpps-vppp)+rll*rmm*(dvppsdy-dvpppdy)
   hmz(2,3)=(drlldz*rmm+rll*drmmdz)*(vpps-vppp)+rll*rmm*(dvppsdz-dvpppdz)
   hmx(2,4)=(drlldx*rnn+rll*drnndx)*(vpps-vppp)+rll*rnn*(dvppsdx-dvpppdx)
   hmy(2,4)=(drlldy*rnn+rll*drnndy)*(vpps-vppp)+rll*rnn*(dvppsdy-dvpppdy)
   hmz(2,4)=(drlldz*rnn+rll*drnndz)*(vpps-vppp)+rll*rnn*(dvppsdz-dvpppdz)
   hmx(3,3)=dvpppdx+2.0d0*rmm*drmmdx*(vpps-vppp)+rmm**2*(dvppsdx-dvpppdx)
   hmy(3,3)=dvpppdy+2.0d0*rmm*drmmdy*(vpps-vppp)+rmm**2*(dvppsdy-dvpppdy)
   hmz(3,3)=dvpppdz+2.0d0*rmm*drmmdz*(vpps-vppp)+rmm**2*(dvppsdz-dvpppdz)
   hmx(3,4)=(drmmdx*rnn+rmm*drnndx)*(vpps-vppp)+rmm*rnn*(dvppsdx-dvpppdx)
   hmy(3,4)=(drmmdy*rnn+rmm*drnndy)*(vpps-vppp)+rmm*rnn*(dvppsdy-dvpppdy)
   hmz(3,4)=(drmmdz*rnn+rmm*drnndz)*(vpps-vppp)+rmm*rnn*(dvppsdz-dvpppdz)
   hmx(4,4)=dvpppdx+2.0d0*rnn*drnndx*(vpps-vppp)+rnn**2*(dvppsdx-dvpppdx)
   hmy(4,4)=dvpppdy+2.0d0*rnn*drnndy*(vpps-vppp)+rnn**2*(dvppsdy-dvpppdy)
   hmz(4,4)=dvpppdz+2.0d0*rnn*drnndz*(vpps-vppp)+rnn**2*(dvppsdz-dvpppdz)
   hmx(1,5)=sq3*(drlldx*rmm+rll*drmmdx)*vsds+sq3*rll*rmm*dvsdsdx
   hmy(1,5)=sq3*(drlldy*rmm+rll*drmmdy)*vsds+sq3*rll*rmm*dvsdsdy
   hmz(1,5)=sq3*(drlldz*rmm+rll*drmmdz)*vsds+sq3*rll*rmm*dvsdsdz
   hmx(1,6)=sq3*(drmmdx*rnn+rmm*drnndx)*vsds+sq3*rmm*rnn*dvsdsdx
   hmy(1,6)=sq3*(drmmdy*rnn+rmm*drnndy)*vsds+sq3*rmm*rnn*dvsdsdy
   hmz(1,6)=sq3*(drmmdz*rnn+rmm*drnndz)*vsds+sq3*rmm*rnn*dvsdsdz
!   hmx(1,7)=sq3*(

 end subroutine set_dhmm
