c**********************************************************************
c                           DENSITY OF STATE
c**********************************************************************
      subroutine dost(na,ns,nm,ks,e,a,dos,dos1,dos2,dos3,nds,caa)
      implicit double precision(a,b,d-h,o-z),integer(i-n),complex*16(c)
      
      dimension e(nm),dos(nds),a(ns),dos1(nds),dos2(nds),dos3(nds)
      complex*16 caa(nm,nm)
c      dimension evr(nm,nm)

c      open(95,file='dos2.dat')

      h=1.05459d-34
c      tt=5.5d-34
      tt=55.0d-34
c      emin=-15.0d0

c      emin=-15.0d0
c      emax=35.0d0

      emin=5.0d0
      emax=15.0d0
c      emin=0.0d0
c      emax=5.0d0
c      emin=-8.5d0

c      emax=7.0d0

c      emax=35.0d0
c     emax=30.0d0
c      nds=1000
      
      ncheck=0
      do ioc=1,nm
         wldos=0.0d0
         wldos1=0.0d0
         wldos2=0.0d0
         wldos3=0.0d0
         total=0.0d0
         do itot=1,nm
            total=total+abs(caa(itot,ioc))**2
         enddo
c         total=dsqrt(total)
         do iloc=1,na
c            if((iloc.eq.13).or.(iloc.eq.16).or.(iloc.eq.18).or.
c     &           (iloc.eq.19))then
c            if((iloc.eq.45))then
c            if((iloc.eq.18).or.(iloc.eq.19)) then  !arm2-A
            if((iloc.eq.17).or.(iloc.eq.18)
     &           .or.(iloc.eq.19).or.(iloc.eq.20))then  !arm4-A
               do iorb=1,4
                  wldos=wldos+abs(caa(4*(iloc-1)+iorb,ioc))**2
               enddo
            endif
c            if((iloc.eq.22).or.(iloc.eq.23)) then  !zig2-B
            if((iloc.eq.21).or.(iloc.eq.22)
     &           .or.(iloc.eq.23).or.(iloc.eq.24))then  !arm4-B
               do iorb=1,4
                  wldos1=wldos1+abs(caa(4*(iloc-1)+iorb,ioc))**2
               enddo
            endif
c            if((iloc.eq.26).or.(iloc.eq.27)) then  !zig2-C
            if((iloc.eq.25).or.(iloc.eq.26)
     &           .or.(iloc.eq.27).or.(iloc.eq.28))then  !arm4-C
               do iorb=1,4
                  wldos2=wldos2+abs(caa(4*(iloc-1)+iorb,ioc))**2
               enddo
            endif
            if((iloc.eq.29).or.(iloc.eq.30)
     &           .or.(iloc.eq.31).or.(iloc.eq.32))then  !arm4-D
               do iorb=1,4
                  wldos3=wldos3+abs(caa(4*(iloc-1)+iorb,ioc))**2
               enddo
            endif
         enddo

c     do icheck=1,nm/4
c            if(abs(evr(4*(icheck-1)+1,ioc)).lt.1.0d-15.or.
c     &         abs(evr(4*(icheck-1)+4,ioc)).lt.1.0d-15) then 
c               ncheck=1
c            else
c               ncheck=0
c            endif
c         enddo
c         if(ncheck.eq.0) goto 1
         do i=1,nds
            if (abs((emax-emin)*i/nds+emin-e(ioc)).le.0.01d0) then
               dos(i)=dos(i)+(2.0d0*sin(
     &              ((emax-emin)*i/nds+emin-e(ioc))*tt/h*2.0d0)/
     &              ((emax-emin)*i/nds+emin-e(ioc)))**2.0d0*a(ks)
     &              /(3.141592654d0)/(2.0d0/h*tt)**2
     &              *wldos/total
               dos1(i)=dos1(i)+(2.0d0*sin(
     &              ((emax-emin)*i/nds+emin-e(ioc))*tt/h*2.0d0)/
     &              ((emax-emin)*i/nds+emin-e(ioc)))**2.0d0*a(ks)
     &              /(3.141592654d0)/(2.0d0/h*tt)**2
     &              *wldos1/total
               dos2(i)=dos2(i)+(2.0d0*sin(
     &              ((emax-emin)*i/nds+emin-e(ioc))*tt/h*2.0d0)/
     &              ((emax-emin)*i/nds+emin-e(ioc)))**2.0d0*a(ks)
     &              /(3.141592654d0)/(2.0d0/h*tt)**2
     &              *wldos2/total
               dos3(i)=dos3(i)+(2.0d0*sin(
     &              ((emax-emin)*i/nds+emin-e(ioc))*tt/h*2.0d0)/
     &              ((emax-emin)*i/nds+emin-e(ioc)))**2.0d0*a(ks)
     &              /(3.141592654d0)/(2.0d0/h*tt)**2
     &              *wldos3/total
            endif
c     if (abs((emax-emin)*(i)/nds+emin-e(ioc)).le.h/tt) then
c     dos(i)=dos(i)+(tt/h)**2.0d0
c     endif
         enddo
         continue
      enddo
c      do ioc=nm/2+1,nm
c         do i=1,nds
c      if (abs((emax-emin)*i/nds+emin-e(ioc)).le.h/tt) then
c               dos(i)=dos(i)+h/6.0d0*(2.0d0*sin(
c     &              ((emax-emin)*i/nds+emin-e(ioc))*tt/h*2.0d0)/
c     &              ((emax-emin)*i/nds+emin-e(ioc)))**2.0d0*a(ks)
c     &              /(3.141592654d0*2.0d0/h*tt)
c      endif
c         enddo
c        continue
c      enddo
      if (ks.eq.ns) then
         do i=1,nds
c            if(dos(i).lt.0.0002d0) dos(i)=0.0d0
            write(94,*) (emax-emin)*(i)/nds+emin,dos(i),dos1(i),dos2(i)
     &           ,dos3(i)
         enddo
      write(94,*) "  "
      endif

      
      return
      end
