!C  *****************************************************************
!C
!C      SUBROUTINE Knano   ONLY ONE K POINT (ZERO VECTOR)
!C
!C  ****************************************************************
!      subroutine knano(NS,XS,YS,ZS,A,pi,a1,a2,a3)
subroutine knano
  use variables
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
!      DIMENSION XS(NS),YS(NS),ZS(NS),A(NS),a1(3),a2(3),a3(3)
      pi=4.0d0*DATAN(1.0d0)
      v=a1(1)*a2(2)*a3(3)
      b1x=pi/a1(1)
      b2y=pi/a2(2)
      b3z=pi/a3(3)
!c      b1x=2.0d0*pi/a1(1)
!c      b2y=2.0d0*pi/a2(2)
!c      b3z=2.0d0*pi/a3(3)

      do ik=1,ns
         XS(IK)=0.0D0
         YS(IK)=0.0D0
         if(ns.eq.1) zs(ik)=0.0d0
         if(ns.ne.1) ZS(IK)=b3z*(ik-1)/(ns-1)
         ak(IK)=1.0D0/ns
      enddo
!C     IK=2
!C      XS(IK)=0.0D0
!C      YS(IK)=0.0D0
!C      ZS(IK)=b3z/2.0d0
!C      AK(IK)=1.0D0/ns

      RETURN
      END
