!      SUBROUTINE md(na,fx,fy,fz,x,y,z,vx,vy,vz,slx,sly,slz,dt,wm,ire,gamma,tempc,ivs)
subroutine md(dt,wm,tempc,ivs)
  use variables

      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C) 
!      DIMENSION x(na),y(na),z(na)
!      dimension xo(na),yo(na),zo(na)
!      dimension xa(na),ya(na),za(na)
!      dimension px(na),py(na),pz(na)
!      dimension fx(na),fy(na),fz(na)
!      dimension vx(na),vy(na),vz(na)

      n=na

      slx=a1(1)
      sly=a2(2)
      slz=a3(3)

      
!c-----줿ϤѤƸҤ򣱥ƥåư
!     Unit of length: Bohr
      do 110 k=1,n
!         xa(k)=2.0d0*x(k)-xo(k)+dt**2/wm*fx(k)*1.0d10/0.529177d0
!         ya(k)=2.0d0*y(k)-yo(k)+dt**2/wm*fy(k)*1.0d10/0.529177d0
!         za(k)=2.0d0*z(k)-zo(k)+dt**2/wm*fz(k)*1.0d10/0.529177d0
         xa(k)=x(k)+dt*vx(k)+dt**2/wm*fx(k)*1.0d10/0.529177d0
         ya(k)=y(k)+dt*vy(k)+dt**2/wm*fy(k)*1.0d10/0.529177d0
         za(k)=z(k)+dt*vz(k)+dt**2/wm*fz(k)*1.0d10/0.529177d0
 110  continue
!c-----ư̤η׻
      do 120 k=1,n
!         px(k)=(xa(k)-x(k))/dt*wm
!         py(k)=(ya(k)-y(k))/dt*wm
!         pz(k)=(za(k)-z(k))/dt*wm
         vx(k)=(xa(k)-x(k))/dt
         vy(k)=(ya(k)-y(k))/dt
         vz(k)=(za(k)-z(k))/dt
!         px(k)=vx(k)*wm
!         py(k)=vy(k)*wm
!         pz(k)=vz(k)*wm
 120  continue
!c-----ưͥ륮η׻
      enkin=0.0d0
      do 105 k=1,n
!         enkin=enkin+(px(k)**2+py(k)**2+pz(k)**2)/wm/2.0d0
         enkin=enkin+(vx(k)**2+vy(k)**2+vz(k)**2)*wm/2.0d0
 105  continue
      ary=0.529177d0*0.529177d0
      temp=2*enkin/3/n/(1.38054d-23)*1.0d-20*ary
!      print *,'Temp = ', temp

!c-----®٥
!c      if (mod(ire,5).eq.0) then
!      tempc=300.0d0
      if (ivs>0) then
         s=dsqrt(tempc/temp)
!      s=0.0d0
         do 389 k=1,n
!            xa(k)=(xa(k)-x(k))*s+x(k)
!            ya(k)=(ya(k)-y(k))*s+y(k)
!            za(k)=(za(k)-z(k))*s+z(k)
            vx(k)=vx(k)*s
            vy(k)=vy(k)*s
            vz(k)=vz(k)*s
 389     continue
      endif
!      if (temp>500.0) then
!         vx=0.0
!         vy=0.0
!         vz=0.0
!      endif


!c      do 202 k=1,n
!c         if (za(k).lt.0.0d0) then
!c            za(k)=za(k)+slz
!c            z(k)=z(k)+slz
!c            xa(k)=xa(k)+slz*dtan(gamma)
!c            x(k)=x(k)+slz*dtan(gamma)
!c         endif
!c         if (za(k).gt.slz) then
!c            za(k)=za(k)-slz
!c            z(k)=z(k)-slz
!c            xa(k)=xa(k)-slz*dtan(gamma)
!c            x(k)=x(k)-slz*dtan(gamma)
!c         endif
!c         if (ya(k).lt.0.0d0) then
!c            ya(k)=ya(k)+sly
!c            y(k)=y(k)+sly
!c         endif
!c         if (ya(k).gt.sly) then
!c            ya(k)=ya(k)-sly
!c            y(k)=y(k)-sly
!c         endif
!c         if (xa(k).lt.0.0d0+dtan(gamma)*za(k)) then
!c            xa(k)=xa(k)+slx
!c            x(k)=x(k)+slx
!c         endif
!c         if (xa(k).gt.slx+dtan(gamma)*za(k)) then
!c            xa(k)=xa(k)-slx
!c            x(k)=x(k)-slx
!c         endif
!c 202  continue
    
         do k=1,na
           if (xa(k).le.-slx/2.0d0)then
            xa(k)=xa(k)+slx
            x(k)=x(k)+slx
           endif
           if (xa(k).gt.slx/2.0d0)then
            xa(k)=xa(k)-slx
            x(k)=x(k)-slx
           endif
           if (ya(k).le.-sly/2.0d0)then
            ya(k)=ya(k)+sly
            y(k)=y(k)+sly
           endif
           if (ya(k).gt.sly/2.0d0)then
            ya(k)=ya(k)-sly
            y(k)=y(k)-sly
           endif
           if (za(k).le.0.0d0)then
            za(k)=za(k)+slz
            z(k)=z(k)+slz
          endif
           if (za(k).gt.slz)then
            za(k)=za(k)-slz
            z(k)=z(k)-slz
           endif
         enddo
!c-----ǡ
!c     print *,'istep=',istep,enpot,enkin,enpot+enkin
!c     write (20,*) istep,enpot,enkink,enpot+enkin
!c      write (20,*) istep,x(2),y(2),z(2)
!c      write (22,*) x(1),y(1),z(1)


          
      
!c-----֤ΥǡĤ餹
      do k=1,n
!         xo(k)=x(k)
!         yo(k)=y(k)
!         zo(k)=z(k)
         x(k)=xa(k)
         y(k)=ya(k)
         z(k)=za(k)
      enddo
      
         
   end
      


