C  *****************************************************************
C
C      SUBROUTINE RGCELL     MM1,MM2,MM3  FOR ST113 CELL
C
C  ****************************************************************
      SUBROUTINE RGCELL(a1,a2,a3,MM1,MM2,MM3,RSS,RR1,RR2,RR3)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION a1(3),a2(3),a3(3)
      RRR=a1(1)*a2(2)*a3(3)+a1(2)*a2(3)*a3(1)+a1(3)*a2(1)*a3(2)
     &   -a1(1)*a2(3)*a3(2)-a1(3)*a2(2)*a3(1)-a1(2)*a2(1)*a3(3)
      RRR=DABS(RRR)
      R12=(a1(2)*a2(3)-a1(3)*a2(2))**2
     &   +(a1(3)*a2(1)-a1(1)*a2(3))**2
     &   +(a1(1)*a2(2)-a1(2)*a2(1))**2
      R23=(a2(2)*a3(3)-a2(3)*a3(2))**2
     &   +(a2(3)*a3(1)-a2(1)*a3(3))**2
     &   +(a2(1)*a3(2)-a2(2)*a3(1))**2
      R31=(a3(2)*a1(3)-a3(3)*a1(2))**2
     &   +(a3(3)*a1(1)-a3(1)*a1(3))**2
     &   +(a3(1)*a1(2)-a3(2)*a1(1))**2
      D12=DSQRT(R12)
      D23=DSQRT(R23)
      D31=DSQRT(R31)
      RR1=RRR/D23
      RR2=RRR/D31
      RR3=RRR/D12
      MM1=RSS/RR1+1.0D0
      MM2=RSS/RR2+1.0D0
      MM3=RSS/RR3+1.0D0
C      print *,a1(1),a2(2),a3(3)
C      print *,RSS,RR1,RR2,RR3
      RETURN
      END
