************************************************************************
       SUBROUTINE SPLF(XX, N, YY, C, NC, V, M, F,  IER)
************************************************************************

       IMPLICIT REAL*8(A-H,O-Z)
       DIMENSION xx(0:N), yy(0:N), C(0:N,3)
C
      IF (N .LT. 2 .OR. M .LT. 1 .OR. NC .LT. N-1) THEN
       IER = 2
       WRITE(*,*) '(SUBR. SPLF) INVALID ARGUMENT. ', N, NC, M
       RETURN
      ENDIF

      IER = 0
      I = 0

       V1 = V - xx(I)
       IF (V1) 10, 30, 40
   10  IF (I .GT. 1) GO TO 20
       IER = 1
       GO TO 80
   20  I = I - 1
       V1 = V - xx(I)
       IF (V1) 10, 30, 80
   30  F = yy(I)
       GO TO 90
   40  IF (I .LT. N) GO TO 50
       IER = 1
       I = N - 1
       GO TO 80
   50  V2 = V - xx(I+1)
       IF (V2) 80, 60, 70
   60  I = I + 1
       GO TO 30
   70  I = I + 1
       V1 = V2
       GO TO 40
   80  F = yy(I) + V1 * (C(I,1) + V1 * (C(I,2) + V1 * C(I,3)))

 90    RETURN
       END
