C**********************************************************************
C                        INITIAL-NANO-ARMCHAIR
C**********************************************************************
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      parameter(na=4,man=1000)
      dimension x(na),y(na),z(na),
     &          xnt(man),ynt(man),znt(man),
     &          a1(3),a2(3),a3(3)

      ao=1.42d0
      ncopy=6
      katom=na
      nlayer=1
      pi=4.0D0*DATAN(1.0D0)  !߼Ψ


      a1(1)=ao*3.0d0
      a1(2)=0.0d0
      a1(3)=0.0d0

      a2(1)=0.0d0
      a2(2)=ao*dsqrt(3.0d0)
      a2(3)=0.0d0

      a3(1)=0.0d0
      a3(2)=0.0d0
      a3(3)=6.696d0/1.42d0*ao
                                 !c=6.696 ʣ
                                 !c=1.42  ʣ
      



c     Ҥν
      x(1)=0.0d0
      y(1)=ao*dsqrt(3.0d0)/2.0d0
      z(1)=0.0d0

      x(2)=ao/2.0d0
      y(2)=0.0d0
      z(2)=0.0d0

      x(3)=ao*3.0d0/2.0d0
      y(3)=0.0d0
      z(3)=0.0d0

      x(4)=ao*2.0d0
      y(4)=ao*dsqrt(3.0d0)/2.0d0
      z(4)=0.0d0

      do i=1,na
         xnt(i)=x(i)
         ynt(i)=y(i)
         znt(i)=z(i)
      enddo
c      trans=a1(1)
      trans=a2(2)
      do i=2,ncopy
         do j=1,na
            katom=katom+1
c            xnt(katom)=x(j)+a1(1)
c            ynt(katom)=y(j)
            xnt(katom)=x(j)
            ynt(katom)=y(j)+a2(2)
            znt(katom)=z(j)
         enddo
c         a1(1)=trans*i
         a2(2)=trans*i
      enddo

      do i=1,katom
c         znt(i)=ynt(i)
         znt(i)=xnt(i)
c         xx=xnt(i)
         xx=ynt(i)
c         xnt(i)=a1(1)/(2.0d0*pi)*dcos(2.0d0*pi*xx/a1(1))
c         ynt(i)=a1(1)/(2.0d0*pi)*dsin(2.0d0*pi*xx/a1(1))
         xnt(i)=a2(2)/(2.0d0*pi)*dcos(2.0d0*pi*xx/a2(2))
         ynt(i)=a2(2)/(2.0d0*pi)*dsin(2.0d0*pi*xx/a2(2))
      enddo

c      a3(3)=a2(2)
      a3(3)=a1(1)
      a3o=a3(3)
      knano=katom
      do j=2,nlayer
         do i=1,katom
            knano=knano+1
            xnt(knano)=xnt(i)
            ynt(knano)=ynt(i)
            znt(knano)=znt(i)+a3(3)
         enddo
         a3(3)=j*a3o
      enddo

c      a1(1)=a1(1)/pi*2.0d0
c      a2(2)=a1(1)

      a2(2)=a2(2)/pi*2.0d0
      a1(1)=a2(2)

      open(50,file='r-nano.dat')
      open(40,file='trans-v-nano.dat')

      print *, knano

      write(40,222) a1(1),a1(2),a1(3)
      write(40,222) a2(1),a2(2),a2(3)
      write(40,222) a3(1),a3(2),a3(3)

      do i=1,knano
         write(50,222) xnt(i),ynt(i),znt(i)
      enddo

      open(60,file='tube.xyz')

      write(60,*) knano
      write(60,*) "0"
      do i=1,knano
         write(60,111) xnt(i),ynt(i),znt(i)
      enddo

 111  format("c",d16.8,d16.8,d16.8)
 222  format(1x,d26.16,d26.16,d26.16)



      end
