C  *****************************************************************    
C                                                                       
C      SUBROUTINE KMESH  K POINTS MESH IN THE HALF OF B.Z.              
C          Only for orthorhombic lattice                                
C  ****************************************************************     
      SUBROUTINE KMESH(NS,XS,YS,ZS,A,MX,MY,MZ,a1,a2,a3,pi)              
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C)
      DIMENSION XS(NS),YS(NS),ZS(NS),a1(3),a2(3),a3(3),A(NS)           
      DX=2.0D0*PI/a1(1)/MX
      DY=2.0D0*PI/a2(2)/MY
      DZ=PI/a3(3)/MZ
      DXM=-PI/a1(1)
      DYM=-PI/a2(2)
      IK=0
      DO 10 IX=1,MX
      DO 20 IY=1,MY
      DO 30 IZ=1,MZ
      IK=IK+1
      XS(IK)=DX*(IX-0.50D0)+DXM                                         
      YS(IK)=DY*(IY-0.50D0)+DYM                                         
      ZS(IK)=DZ*(IZ-0.50D0)                                             
      A(IK)=1.0D0/NS
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      RETURN                                                            
      END        
