C  *****************************************************************    
C                                                                       
C      SUBROUTINE KSCST    K POINT (30) (SC structure)               
C                                                                      
C  ****************************************************************    
      SUBROUTINE kscst(NS,XS,YS,ZS,A,a1,a2,a3,ao,pi,gamma)
      IMPLICIT DOUBLE PRECISION(A,B,D-H,O-Z),INTEGER(I-N),COMPLEX*16(C) 
      DIMENSION XS(NS),YS(NS),ZS(NS),A(NS),a1(3),a2(3),a3(3)                              
      
c     ճʻҥ٥ȥ 
c      b1x=4.0d0*pi/3.0d0/ao*3.0d0*dsqrt(2.0d0)/2.0d0
c      b1z=-4.0d0*pi/3.0d0/ao*3.0d0*dsqrt(2.0d0)/2.0d0*dtan(gamma)
c      b2y=4.0d0*pi/3.0d0/ao*dsqrt(3.0d0/2.0d0)
c      b3z=4.0d0*pi/3.0d0/ao*dsqrt(3.0d0)/2.0d0

c      print *,b1x,b1z,b2y,b3z

      v=a1(1)*a2(2)*a3(3)
      b1x=2.0d0*pi/v*a2(2)*a3(3)
      b1z=-2.0d0*pi/v*a2(2)*a3(1)
      b2y=2.0d0*pi/v*a3(3)*a1(1)
      b3z=2.0d0*pi/v*a1(1)*a2(2)
      
c      print *,b1x,b1z,b2y,b3z
      
      mx=4
      my=4
      mz=4
      
      ik=0
      DO 10 IX=1,MX
      DO 20 IY=1,MY
      DO 30 IZ=1,MZ
      IK=IK+1
      XS(IK)=b1x*(2.0d0*dble(ix)-dble(mx)-1.0d0)/(2.0d0*dble(mx))                                        
      YS(IK)=b2y*(2.0d0*dble(iy)-dble(my)-1.0d0)/(2.0d0*dble(my))                                       
      ZS(IK)=b1z*(2.0d0*dble(ix)-dble(mx)-1.0d0)/(2.0d0*dble(mx))
     &      +b3z*(2.0d0*dble(iz)-dble(mz)-1.0d0)/(2.0d0*dble(mz))                     
      A(IK)=1.0D0/NS
   30 CONTINUE
   20 CONTINUE
   10 CONTINUE
      
      
      RETURN                                                           
      END    
