module parambsSiC
  double precision :: lambda(2), & !1:C, 2:Si
       a_s(4),b_s(4),c_s(4),d_s(4), & !1:C, 2:Si, 3:C on Si, 4: Si on C
       a_p(4),b_p(4),c_p(4),d_p(4), &
       a_t2g(4),b_t2g(4),c_t2g(4),d_t2g(4), &
       a_eg(4),b_eg(4),c_eg(4),d_eg(4), &
       he_sss(3),hf_sss(3),hfbar_sss(3),hg_sss(3), & !Hamiltonian
       he_sps(3),hf_sps(3),hfbar_sps(3),hg_sps(3), & !1:C, 2:Si, 3:C-Si/Si-C
       he_pps(3),hf_pps(3),hfbar_pps(3),hg_pps(3), &
       he_ppp(3),hf_ppp(3),hfbar_ppp(3),hg_ppp(3), &
       he_sds(3),hf_sds(3),hfbar_sds(3),hg_sds(3), &
       he_pds(3),hf_pds(3),hfbar_pds(3),hg_pds(3), &
       he_pdp(3),hf_pdp(3),hfbar_pdp(3),hg_pdp(3), &
       he_dds(3),hf_dds(3),hfbar_dds(3),hg_dds(3), &
       he_ddp(3),hf_ddp(3),hfbar_ddp(3),hg_ddp(3), &
       he_ddd(3),hf_ddd(3),hfbar_ddd(3),hg_ddd(3), &
       se_sss(3),sf_sss(3),sfbar_sss(3),sg_sss(3), & !Overlap
       se_sps(3),sf_sps(3),sfbar_sps(3),sg_sps(3), &
       se_pps(3),sf_pps(3),sfbar_pps(3),sg_pps(3), &
       se_ppp(3),sf_ppp(3),sfbar_ppp(3),sg_ppp(3), &
       se_sds(3),sf_sds(3),sfbar_sds(3),sg_sds(3), &
       se_pds(3),sf_pds(3),sfbar_pds(3),sg_pds(3), &
       se_pdp(3),sf_pdp(3),sfbar_pdp(3),sg_pdp(3), &
       se_dds(3),sf_dds(3),sfbar_dds(3),sg_dds(3), &
       se_ddp(3),sf_ddp(3),sfbar_ddp(3),sg_ddp(3), &
       se_ddd(3),sf_ddd(3),sfbar_ddd(3),sg_ddd(3)
  double precision :: ro=12.5d0, rlo=0.5d0 !PRB62-4478(2000)
  double precision, allocatable :: rho(:,:),drhox2(:,:,:),drhoy2(:,:,:),drhoz2(:,:,:)
  logical :: initialize_bsSiC = .true.
end module parambsSiC
