!subroutine registration2(na,man,rc,rr2,a1x,a1y,a1z,a2x,a2y,a2z, &
!     a3x,a3y,a3z,x,y,z,dx,dy,dz,ip,nn)
subroutine registration2
  use variables
  implicit double precision(a,b,d-h,o-z),integer(i-n),complex*16(c)
!  dimension x(na),y(na),z(na),dx(man,na),dy(man,na),dz(man,na),
!  &          ip(man,na),nn(na)
  a1x=a1(1)
  a1y=a1(2)
  a1z=a1(3)
  a2x=a2(1)
  a2y=a2(2)
  a2z=a2(3)
  a3x=a3(1)
  a3y=a3(2)
  a3z=a3(3)

!c-----Υ
      ss1=dsqrt(a1x**2+a1y**2+a1z**2)
      ss2=dsqrt(a2x**2+a2y**2+a2z**2)
      ss3=dsqrt(a3x**2+a3y**2+a3z**2)
!c-----γϿ
!c         rc=slz
      mm1=rc/ss1+1
      mm2=rc/ss2+1
      mm3=rc/ss3+1
!      print '(1x,"mm1=",i4,", mm2=",i4,", mm3=",i4)',mm1,mm2,mm3

!c      mm1=0
!c      mm2=0
!c      mm3=0
      do i=1,na
         nt=0
         do j=1,na
            do mrl=-mm1,mm1
               do mrm=-mm2,mm2
                  do mrn=-mm3,mm3
                     xx=x(j)+a1x*mrl+a2x*mrm+a3x*mrn-x(i)
                     yy=y(j)+a1y*mrl+a2y*mrm+a3y*mrn-y(i)
                     zz=z(j)+a1z*mrl+a2z*mrm+a3z*mrn-z(i)
                     if (((abs(xx).le.rc).and.(abs(yy).le.rc)) &
                          .and.(abs(zz).le.rc)) then
                        r2=xx**2+yy**2+zz**2
                        if (r2.lt.rr2) then
                           if (r2.gt.0.0d0) then
                              nt=nt+1
                              if(nt.gt.man) print *, 'error'
                              dx(nt,i)=xx
                              dy(nt,i)=yy
                              dz(nt,i)=zz
                              ip(nt,i)=j
                           endif
                        endif
                     endif
                  enddo
               enddo
            enddo
         enddo
         nn(i)=nt
!         print *, nt,i
      enddo

      return
    end subroutine registration2
